# tags


def generate_NAME_stem(name=str):
    return [
        {'item': f'{name}_stem', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_stem', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'stripped_{name}_stem'},
            {'item': f'{name}_slab', 'count': 1}
        ]}
    ]
def generate_stripped_NAME_stem(name=str):
    return [
        {'item': f'stripped_{name}_stem', 'count': 1, 'condition': ['!player']},
        {'item': f'stripped_{name}_stem', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_fence'},
            {'item': f'{name}_slab', 'count': 4}
        ]}
    ]
def generate_NAME_hyphae(name=str):
    return [
        {'item': f'{name}_hyphae', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_hyphae', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'stripped_{name}_hyphae'},
            {'item': f'{name}_slab', 'count': 1}
        ]}
    ]
def generate_stripped_NAME_hyphae(name=str):
    return [
        {'item': f'stripped_{name}_hyphae', 'count': 1, 'condition': ['!player']},
        {'item': f'stripped_{name}_hyphae', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_fence'},
            {'item': f'{name}_slab', 'count': 4}
        ]}
    ]
def generate_NAME_fence(name=str):
    return [
        {'item': f'{name}_fence', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_fence', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'{name}_slab', 'count': 3}
        ]}
    ]



def generate_NAME_log(name=str):
    return [
        {'item': f'{name}_log', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_log', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'stripped_{name}_log'},
            {'item': f'{name}_slab', 'count': 1}
        ]}
    ]
def generate_stripped_NAME_log(name=str):
    return [
        {'item': f'stripped_{name}_log', 'count': 1, 'condition': ['!player']},
        {'item': f'stripped_{name}_log', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_fence'},
            {'item': f'{name}_slab', 'count': 4}
        ]}
    ]
def generate_NAME_wood(name=str):
    return [
        {'item': f'{name}_wood', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_wood', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'stripped_{name}_wood'},
            {'item': f'{name}_slab', 'count': 1}
        ]}
    ]
def generate_stripped_NAME_wood(name=str):
    return [
        {'item': f'stripped_{name}_wood', 'count': 1, 'condition': ['!player']},
        {'item': f'stripped_{name}_wood', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_fence'},
            {'item': f'{name}_slab', 'count': 4}
        ]}
    ]
def generate_NAME_fence(name=str):
    return [
        {'item': f'{name}_fence', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_fence', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'{name}_slab', 'count': 3}
        ]}
    ]

def generate_NAME_planks(name=str):
    return [
        {'item': f'{name}_planks', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_planks', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_stairs'},
            {'item': f'{name}_slab', 'count': 1}
        ]}
    ]

def generate_polished_NAME(name=str):
    return [
        {'item': f'polished_{name}', 'count': 1, 'condition': ['!player']},
        {'item': f'polished_{name}', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}'}
        ]}
    ]
def generate_NAME(name=str):
    return [
        {'item': f'{name}', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_stairs'},
            {'item': f'{name}_slab', 'count': 1}

        ]}
    ]
def generate_NAME_bricks(name=str):
    return [
        {'item': f'{name}s', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}s', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_stairs'},
            {'item': f'{name}_slab', 'count': 1}

        ]}
    ]
def generate_NAME_stairs(name=str):
    return [
        {'item': f'{name}_stairs', 'count': 1, 'condition': ['!player']},
        {'item': f'{name}_stairs', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'{name}_slab'}
        ]}
    ]
# def generate_NAME_slab(name=str):
#     return [
#         {'item': f'{name}_slab', 'count': 1, 'condition': ['!player']},
#         {'item': f'{name}_slab', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
#         {'roll_list':[
#             {'item': f'{name}_slab', 'count': 1}
#         ]}
#     ]
def generate_DROP_and_SELFDROP(drop, selfdrop):
    return [
        {'item': drop, 'count': 1, 'condition': ['!player']},
        {'item': selfdrop, 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': drop}

        ]}
    ]
def generate_DROP_and_SELFDROP_2(drop, selfdrop):
    return [
        {'item': selfdrop, 'count': 1, 'condition': ['!player']},
        {'item': selfdrop, 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': drop}

        ]}
    ]
def generate_DROP_and_SELFDROP_3(drop, selfdrop):
    return [
        {'item': selfdrop, 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': drop}
        ]}
    ]
def generate_DROP_and_SELFDROP_4(setblock, drop, selfdrop):
    return [
        {'item': selfdrop, 'count': 1, 'condition': ['!player']},
        {'item': selfdrop, 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': setblock},
            {'item': drop, 'count': 1}
        ]}
    ]

custom_block_drops = {
    'purpur_block': generate_DROP_and_SELFDROP_4('purpur_stairs', 'purpur_slab', 'purpur_block'),
    'purpur_stairs': generate_NAME_stairs('purpur'),

    'bamboo_block': generate_DROP_and_SELFDROP_2('stripped_bamboo_block', 'bamboo_block'),
    'stripped_bamboo_block': generate_DROP_and_SELFDROP_4('bamboo_slab', 'bamboo_slab', 'stripped_bamboo_block'),

    'crimson_stem': generate_NAME_stem('crimson'),
    'warped_stem': generate_NAME_stem('warped'),
    'crimson_hyphae': generate_NAME_hyphae('crimson'),
    'warped_hyphae': generate_NAME_hyphae('warped'),

    'oak_log': generate_NAME_log('oak'),
    'spruce_log': generate_NAME_log('spruce'),
    'birch_log': generate_NAME_log('birch'),
    'jungle_log': generate_NAME_log('jungle'),
    'acacia_log': generate_NAME_log('acacia'),
    'dark_oak_log': generate_NAME_log('dark_oak'),
    'mangrove_log': generate_NAME_log('mangrove'),
    'cherry_log': generate_NAME_log('cherry'),

    'stripped_oak_log': generate_stripped_NAME_log('oak'),
    'stripped_spruce_log': generate_stripped_NAME_log('spruce'),
    'stripped_birch_log': generate_stripped_NAME_log('birch'),
    'stripped_jungle_log': generate_stripped_NAME_log('jungle'),
    'stripped_acacia_log': generate_stripped_NAME_log('acacia'),
    'stripped_dark_oak_log': generate_stripped_NAME_log('dark_oak'),
    'stripped_mangrove_log': generate_stripped_NAME_log('mangrove'),
    'stripped_cherry_log': generate_stripped_NAME_log('cherry'),

    'oak_wood': generate_NAME_wood('oak'),
    'spruce_wood': generate_NAME_wood('spruce'),
    'birch_wood': generate_NAME_wood('birch'),
    'jungle_wood': generate_NAME_wood('jungle'),
    'acacia_wood': generate_NAME_wood('acacia'),
    'dark_oak_wood': generate_NAME_wood('dark_oak'),
    'mangrove_wood': generate_NAME_wood('mangrove'),
    'cherry_wood': generate_NAME_wood('cherry'),

    'stripped_oak_wood': generate_stripped_NAME_wood('oak'),
    'stripped_spruce_wood': generate_stripped_NAME_wood('spruce'),
    'stripped_birch_wood': generate_stripped_NAME_wood('birch'),
    'stripped_jungle_wood': generate_stripped_NAME_wood('jungle'),
    'stripped_acacia_wood': generate_stripped_NAME_wood('acacia'),
    'stripped_dark_oak_wood': generate_stripped_NAME_wood('dark_oak'),
    'stripped_mangrove_wood': generate_stripped_NAME_wood('mangrove'),
    'stripped_cherry_wood': generate_stripped_NAME_wood('cherry'),

    'oak_fence': generate_NAME_fence('oak'),
    'spruce_fence': generate_NAME_fence('spruce'),
    'birch_fence': generate_NAME_fence('birch'),
    'jungle_fence': generate_NAME_fence('jungle'),
    'acacia_fence': generate_NAME_fence('acacia'),
    'dark_oak_fence': generate_NAME_fence('dark_oak'),
    'mangrove_fence': generate_NAME_fence('mangrove'),
    'cherry_fence': generate_NAME_fence('cherry'),
    'crimson_fence': generate_NAME_fence('crimson'),
    'warped_fence': generate_NAME_fence('warped'),

    'oak_planks': generate_NAME_planks('oak'),
    'spruce_planks': generate_NAME_planks('spruce'),
    'birch_planks': generate_NAME_planks('birch'),
    'jungle_planks': generate_NAME_planks('jungle'),
    'acacia_planks': generate_NAME_planks('acacia'),
    'dark_oak_planks': generate_NAME_planks('dark_oak'),
    'mangrove_planks': generate_NAME_planks('mangrove'),
    'cherry_planks': generate_NAME_planks('cherry'),
    'bamboo_planks': generate_NAME_planks('bamboo'),
    'crimson_planks': generate_NAME_planks('crimson'),
    'warped_planks': generate_NAME_planks('warped'),


    'stone': [
        {'item': f'cobblestone', 'count': 1, 'condition': ['!player']},
        {'item': f'stone', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'cobblestone'}
        ]}
    ],
    'deepslate': [
        {'item': f'cobbled_deepslate', 'count': 1, 'condition': ['!player']},
        {'item': f'deepslate', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': f'cobbled_deepslate'}
        ]}
    ],
    'polished_granite': generate_polished_NAME('granite'),
    'polished_andesite': generate_polished_NAME('andesite'),
    'polished_diorite': generate_polished_NAME('diorite'),
    'polished_blackstone': generate_polished_NAME('blackstone'),
    'polished_deepslate': generate_polished_NAME('deepslate'),
    'polished_basalt': generate_polished_NAME('basalt'),



    'cobblestone': generate_NAME('cobblestone'),
    'mossy_cobblestone': generate_NAME('mossy_cobblestone'),
    'cobbled_deepslate': generate_NAME('cobbled_deepslate'),
    'andesite': generate_NAME('andesite'),
    'diorite': generate_NAME('diorite'),
    'granite': generate_NAME('granite'),
    'sandstone': generate_NAME('sandstone'),
    'red_sandstone': generate_NAME('red_sandstone'),
    'prismarine': generate_NAME('prismarine'),
    'dark_prismarine': generate_NAME('dark_prismarine'),
    'blackstone': generate_NAME('blackstone'),

    'stone_bricks': generate_NAME_bricks('stone_brick'),
    'mossy_stone_bricks': generate_NAME_bricks('mossy_stone_brick'),
    'deepslate_bricks': generate_NAME_bricks('deepslate_brick'),
    'mud_bricks': generate_NAME_bricks('mud_brick'),
    'polished_blackstone_bricks': generate_NAME_bricks('polished_blackstone_brick'),
    'prismarine_bricks': generate_NAME_bricks('prismarine_brick'),
    'end_stone_bricks': generate_NAME_bricks('end_stone_brick'),

    'stone_brick_stairs': generate_NAME_stairs('stone_brick'),
    'mossy_stone_brick_stairs': generate_NAME_stairs('mossy_stone_brick'),
    'deepslate_brick_stairs': generate_NAME_stairs('deepslate_brick'),
    'mud_brick_stairs': generate_NAME_stairs('mud_brick'),
    'polished_blackstone_brick_stairs': generate_NAME_stairs('polished_blackstone_brick'),
    'prismarine_brick_stairs': generate_NAME_stairs('prismarine_brick'),
    'end_stone_brick_stairs': generate_NAME_stairs('end_stone_brick'),

    'cobblestone_stairs': generate_NAME_stairs('cobblestone'),
    'mossy_cobblestone_stairs': generate_NAME_stairs('mossy_cobblestone'),
    'cobbled_deepslate_stairs': generate_NAME_stairs('cobbled_deepslate'),
    'andesite_stairs': generate_NAME_stairs('andesite'),
    'diorite_stairs': generate_NAME_stairs('diorite'),
    'granite_stairs': generate_NAME_stairs('granite'),
    'sandstone_stairs': generate_NAME_stairs('sandstone'),
    'red_sandstone_stairs': generate_NAME_stairs('red_sandstone'),
    'prismarine_stairs': generate_NAME_stairs('prismarine'),
    'dark_prismarine_stairs': generate_NAME_stairs('dark_prismarine'),
    'blackstone_stairs': generate_NAME_stairs('blackstone'),

    'oak_stairs': generate_NAME_stairs('oak'),
    'spruce_stairs': generate_NAME_stairs('spruce'),
    'birch_stairs': generate_NAME_stairs('birch'),
    'jungle_stairs': generate_NAME_stairs('jungle'),
    'acacia_stairs': generate_NAME_stairs('acacia'),
    'dark_oak_stairs': generate_NAME_stairs('dark_oak'),
    'mangrove_stairs': generate_NAME_stairs('mangrove'),
    'cherry_stairs': generate_NAME_stairs('cherry'),
    'bamboo_stairs': generate_NAME_stairs('bamboo'),
    'crimson_stairs': generate_NAME_stairs('crimson'),
    'warped_stairs': generate_NAME_stairs('warped'),



    # 'cobblestone_slab': generate_NAME_slab('cobblestone'),
    # 'cobbled_deepslate_slab': generate_NAME_slab('cobbled_deepslate'),
    # 'andesite_slab': generate_NAME_slab('andesite'),
    # 'diorite_slab': generate_NAME_slab('diorite'),
    # 'granite_slab': generate_NAME_slab('granite'),
    # 'sandstone_slab': generate_NAME_slab('sandstone'),
    # 'red_sandstone_slab': generate_NAME_slab('red_sandstone'),
    # 'prismarine_slab': generate_NAME_slab('prismarine'),
    # 'dark_prismarine_slab': generate_NAME_slab('dark_prismarine'),
    # 'blackstone_slab': generate_NAME_slab('blackstone'),

    'grass_block': generate_DROP_and_SELFDROP('dirt', 'grass_block'),
    'podzol': generate_DROP_and_SELFDROP('dirt', 'podzol'),
    'mycelium': generate_DROP_and_SELFDROP('dirt', 'mycelium'),
    'coarse_dirt': generate_DROP_and_SELFDROP_2('dirt', 'coarse_dirt'),
    'rooted_dirt': generate_DROP_and_SELFDROP_2('dirt', 'rooted_dirt'),

    'blue_ice': generate_DROP_and_SELFDROP_3('packed_ice', 'blue_ice'),
    'packed_ice': generate_DROP_and_SELFDROP_3('ice', 'packed_ice'),

    'warped_nylium': generate_DROP_and_SELFDROP('netherrack', 'warped_nylium'),
    'crimson_nylium': generate_DROP_and_SELFDROP('netherrack', 'crimson_nylium'),

    'soul_soil': generate_DROP_and_SELFDROP('soul_sand', 'soul_soil'),

    'smooth_basalt': generate_DROP_and_SELFDROP('basalt', 'smooth_basalt'),

    'magma': generate_DROP_and_SELFDROP_2('netherrack', 'magma'),

    'bricks': [
        {'item': 'bricks', 'count': 1, 'condition': ['!player']},
        {'item': 'bricks', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'brick_stairs'},
            {'item': f'brick', 'count': 1}
        ]}
    ],
    'brick_stairs': [
        {'item': 'brick_stairs', 'count': 1, 'condition': ['!player']},
        {'item': 'brick_stairs', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'brick_slab'},
            {'item': f'brick', 'count': 1}
        ]}
    ],
    'brick_slab': [
        {'item': 'brick_slab', 'count': 1, 'condition': ['!player']},
        {'item': 'brick_slab', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'brick', 'count': 2}
        ]}
    ],

    'nether_bricks': [
        {'item': 'nether_bricks', 'count': 1, 'condition': ['!player']},
        {'item': 'nether_bricks', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'nether_brick_stairs'},
            {'item': f'nether_brick', 'count': 1}
        ]}
    ],
    'nether_brick_stairs': [
        {'item': 'nether_brick_stairs', 'count': 1, 'condition': ['!player']},
        {'item': 'nether_brick_stairs', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'nether_brick_slab'},
            {'item': f'nether_brick', 'count': 1}
        ]}
    ],
    'nether_brick_slab': [
        {'item': 'nether_brick_slab', 'count': 1, 'condition': ['!player']},
        {'item': 'nether_brick_slab', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'nether_brick', 'count': 2}
        ]}
    ],

    'red_nether_bricks': [
        {'item': 'red_nether_bricks', 'count': 1, 'condition': ['!player']},
        {'item': 'red_nether_bricks', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'red_nether_brick_stairs'},
            {'item': f'nether_brick', 'count': 1}
        ]}
    ],
    'red_nether_brick_stairs': [
        {'item': 'red_nether_brick_stairs', 'count': 1, 'condition': ['!player']},
        {'item': 'red_nether_brick_stairs', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'red_nether_brick_slab'}
        ]}
    ],
    'red_nether_brick_slab': [
        {'item': 'red_nether_brick_slab', 'count': 1, 'condition': ['!player']},
        {'item': 'red_nether_brick_slab', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'nether_brick', 'count': 1}
        ]}
    ],

    'budding_amethyst': [{'roll_list':[
            {'stage_break': 'amethyst_block'}
        ]}
    ],
    'amethyst_cluster': [
        {'item': 'amethyst_shard', 'count': 4, 'condition': ['!player']},
        {'item': 'amethyst_cluster', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'large_amethyst_bud'},
            {'item': f'amethyst_shard', 'count': 1}
        ]}
    ],
    'large_amethyst_bud': [
        {'item': 'amethyst_shard', 'count': 3, 'condition': ['!player']},
        {'item': 'large_amethyst_bud', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'medium_amethyst_bud'},
            {'item': f'amethyst_shard', 'count': 1}
        ]}
    ],
    'medium_amethyst_bud': [
        {'item': 'amethyst_shard', 'count': 2, 'condition': ['!player']},
        {'item': 'medium_amethyst_bud', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'small_amethyst_bud'},
            {'item': f'amethyst_shard', 'count': 1}
        ]}
    ],
    'small_amethyst_bud': [
        {'item': 'amethyst_shard', 'count': 1, 'condition': ['!player']},
        {'item': 'small_amethyst_bud', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'item': f'amethyst_shard', 'count': 1}
        ]}
    ],

    'muddy_mangrove_roots': [{'roll_list':[
            {'stage_break': 'mangrove_roots'},
            {'item': f'mud', 'count': 1}
        ]}
    ],




    'nether_quartz_ore': [    
        {'item': 'quartz', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'nether_quartz_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'netherrack'},
            {'item': f'quartz', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'nether_gold_ore': [
        {'item': 'gold_nugget', 'count': {'min':2, 'max':6}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'nether_gold_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'netherrack'},
            {'item': f'gold_nugget', 'count': {'min':2, 'max':6}, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'lapis_ore': [
        {'item': 'lapis_lazuli', 'count': {'min':4, 'max':9}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'lapis_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'lapis_lazuli', 'count': {'min':4, 'max':9}, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_lapis_ore': [
        {'item': 'lapis_lazuli', 'count': {'min':4, 'max':9}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_lapis_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'lapis_lazuli', 'count': {'min':4, 'max':9}, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'gold_ore': [
        {'item': 'raw_gold', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'gold_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'raw_gold', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_gold_ore': [
        {'item': 'raw_gold', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_gold_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'raw_gold', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'iron_ore': [
        {'item': 'raw_iron', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'iron_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'raw_iron', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_iron_ore': [
        {'item': 'raw_iron', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_iron_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'raw_iron', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'emerald_ore': [
        {'item': 'emerald', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'emerald_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'emerald', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_emerald_ore': [
        {'item': 'emerald', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_emerald_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'emerald', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'diamond_ore': [
        {'item': 'diamond', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'diamond_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'diamond', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_diamond_ore': [
        {'item': 'diamond', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_diamond_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'diamond', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'coal_ore': [
        {'item': 'coal', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'coal_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'coal', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_coal_ore': [
        {'item': 'coal', 'count': 1, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_coal_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'coal', 'count': 1, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'copper_ore': [
        {'item': 'raw_copper', 'count': {'min':4, 'max':5}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'copper_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'raw_copper', 'count': {'min':4, 'max':5}, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'deepslate_copper_ore': [
        {'item': 'raw_copper', 'count': {'min':4, 'max':5}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]},
        {'item': 'deepslate_copper_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'raw_copper', 'count': {'min':4, 'max':5}, 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'ore_drops'}]}
        ]}
    ],
    'redstone_ore': [
        {'item': 'redstone', 'count': {'min':4, 'max':5}, 'condition': ['!player'], 'function': ['apply_bonus', {'enchantment':'fortune', 'formula':'uniform_bonus_count', 'parameters': {'bonusMultiplier': 1}}]},
        {'item': 'redstone_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'stone'},
            {'item': f'redstone', 'count': {'min':4, 'max':5}, 'function': ['apply_bonus',{'enchantment':'fortune', 'formula':'uniform_bonus_count', 'parameters': {'bonusMultiplier': 1}}]}
        ]}
    ],
    'deepslate_redstone_ore': [
        {'item': 'redstone', 'count': {'min':4, 'max':5}, 'condition': ['!player'], 'function': ['apply_bonus',{'enchantment':'fortune', 'formula':'uniform_bonus_count', 'parameters': {'bonusMultiplier': 1}}]},
        {'item': 'deepslate_redstone_ore', 'count': 1, 'condition': ['match_tool', {'enchantments': [{'enchantment': 'silk_touch', 'levels':{'min':1}}]}]},
        {'roll_list':[
            {'stage_break': 'deepslate'},
            {'item': f'redstone', 'count': {'min':4, 'max':5}, 'function': ['apply_bonus',{'enchantment':'fortune', 'formula':'uniform_bonus_count', 'parameters': {'bonusMultiplier': 1}}]}
        ]}
    ],


}

# oak
# spruce
# birch
# jungle
# acacia
# dark_oak
# mangrove
# cherry
# warped
# crimson
# bamboo

custom_crafts = {
    'oak_log': ['oak_slab', 'oak_slab', 'oak_slab', 'oak_slab', 'oak_slab', 'oak_slab', 'oak_slab', 'oak_slab', 'oak_planks'],
    'spruce_log': ['spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_slab', 'spruce_planks'],
    'birch_log': ['birch_slab', 'birch_slab', 'birch_slab', 'birch_slab', 'birch_slab', 'birch_slab', 'birch_slab', 'birch_slab', 'birch_planks'],
    'jungle_log': ['jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_slab', 'jungle_planks'],
    'acacia_log': ['acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_slab', 'acacia_planks'],
    'dark_oak_log': ['dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_slab', 'dark_oak_planks'],
    'mangrove_log': ['mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_slab', 'mangrove_planks'],
    'cherry_log': ['cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_slab', 'cherry_planks'],
    'warped_log': ['warped_slab', 'warped_slab', 'warped_slab', 'warped_slab', 'warped_slab', 'warped_slab', 'warped_slab', 'warped_slab', 'warped_planks'],
    'crimson_log': ['crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_slab', 'crimson_planks'],
    'bamboo_block': ['bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_slab', 'bamboo_planks'],

    'oak_planks': ['oak_slab', 'oak_slab'],
    'spruce_planks': ['spruce_slab', 'spruce_slab'],
    'birch_planks': ['birch_slab', 'birch_slab'],
    'jungle_planks': ['jungle_slab', 'jungle_slab'],
    'acacia_planks': ['acacia_slab', 'acacia_slab'],
    'dark_oak_planks': ['dark_oak_slab', 'dark_oak_slab'],
    'mangrove_planks': ['mangrove_slab', 'mangrove_slab'],
    'cherry_planks': ['cherry_slab', 'cherry_slab'],
    'warped_planks': ['warped_slab', 'warped_slab'],
    'crimson_planks': ['crimson_slab', 'crimson_slab'],
    'bamboo_block': ['bamboo_slab', 'bamboo_slab'],

    'stone': ['stone_slab', 'stone_slab'],
    'deepslate': ['deepslate_slab', 'deepslate_slab'],
    'cobblestone': ['cobblestone_slab', 'cobblestone_slab'],
    'mossy_cobblestone': ['mossy_cobblestone_slab', 'mossy_cobblestone_slab'],
    'cobbled_deepslate': ['cobbled_deepslate_slab', 'cobbled_deepslate_slab'],
    'diorite': ['diorite_slab', 'diorite_slab'],
    'andesite': ['andesite_slab', 'andesite_slab'],
    'granite': ['granite_slab', 'granite_slab'],
    'blackstone': ['blackstone_slab', 'blackstone_slab'],
    'prismarine': ['prismarine_slab', 'prismarine_slab'],
    'dark_prismarine': ['dark_prismarine_slab', 'dark_prismarine_slab'],


    'prismarine_bricks': ['prismarine_brick_slab', 'prismarine_brick_slab'],
    'deepslate_bricks': ['deepslate_brick_slab', 'deepslate_brick_slab'],
    'stone_bricks': ['stone_brick_slab', 'stone_brick_slab'],
    'mossy_stone_bricks': ['mossy_stone_brick_slab', 'mossy_stone_brick_slab'],
    'bricks': ['brick_slab', 'brick_slab'],
    'nether_bricks': ['nether_brick_slab', 'nether_brick_slab'],
    'red_nether_bricks': ['red_nether_brick_slab', 'red_nether_brick_slab'],
    'polished_blackstone_bricks': ['polished_blackstone_brick_slab', 'polished_blackstone_brick_slab'],
    'end_stone_bricks': ['end_stone_brick_slab', 'end_stone_brick_slab'],
}